<?php
/*
|--------------------------------------------------------------------------
| tester 体验者设置
|--------------------------------------------------------------------------
*/
namespace Wechat_component\Applet\Src;

use Dever;
use Token\Lib\Wechat;
use Wechat_component\Src\Core;

class Auditing extends Core
{
	public $table = 'wechat_component_applet/auditing';

	public function submit()
	{
		$id = Dever::input('id');
		$info = Dever::db('wechat_component_applet/version')->one($id);
		$user = explode(',', $info['user']);
		foreach ($user as $k => $v) {
			$param = array();
			$param['user_id'] = $v;
			$param['project_id'] = $info['project_id'];
			$param['version_id'] = $info['id'];
			$param['name'] = $info['name'];
			$param['status'] = 1;
			$param['statusDesc'] = '审核中';
			$id = Dever::upinto('wechat_component_applet/auditing', array('option_user_id' => $v, 'option_project_id' => $param['project_id'], 'option_name' => $param['name']), $param);
			$this->set($v, $id);
		}
		Dever::alert('提交成功，请到审核历史中查看审核状态');
		return;
	}

	/**
     * 定期获取审核状态
     * 
     * @return mixed
     */
    public function cron()
    {
        $data = Dever::db('wechat_component_applet/auditing')->state();
        if ($data) {
        	$wechat = array();
        	foreach ($data as $k => $v) {
        		if ($v['status'] == 1 && $v['auditid']) {
        			$user = Dever::db('component/user')->one($v['user_id']);
					$oauth = Dever::db('token/oauth')->one($user['oauth_id']);
					if (!isset($wechat[$v['project_id']])) {
						$wechat[$v['project_id']] = new Wechat($v['project_id'], 'component');
					}
					
					$oauth = $wechat[$v['project_id']]->oauth($oauth['id']);
					$oauth['oauth'] = $oauth['value'];
					$oauth['auditid'] = $v['auditid'];
					$result = $wechat[$v['project_id']]->curl('applet_auditstatus', $oauth, false);
					
					$update = array();
					if (isset($result['status'])) {
						if ($result['status'] == 2) {
							$html['审核状态'] = '审核中';
							$update['status'] = 1;
						} elseif($result['status'] == 1) {
							$html['审核状态'] = '审核失败';
							$update['status'] = 3;
						} else {
							$html['审核状态'] = '审核成功';
							$update['status'] = 2;
						}
					}
					if (isset($result['reason'])) {
						$html['说明'] = $result['reason'];
						$update['statusDesc'] = $result['reason'];
					}

					if ($update) {
						$update['where_id'] = $v['id'];
						Dever::db('wechat_component_applet/auditing')->update($update);
					}
        		}
        	}
        }
    }

	# 查看审核状态
	public function view($id)
	{
		$info = Dever::db('wechat_component_applet/auditing')->one($id);
		$status = $info['status'];
		$html = array();
		if ($status == 2) {
			$html['审核状态'] = '审核成功';
		} elseif ($status == 3) {
			$html['审核状态'] = '审核失败';
			$html['说明'] = $info['statusDesc'];
		} elseif ($status == 1) {
			$html['审核状态'] = '审核中';
		}

		$html = Dever::table($html);
		return $html;
	}

	public function handle($oauth, $info, $delete, $user, $wechat)
	{
		$oauth['method'] = 'applet_submit';
		$project = Dever::db('token/project')->one($info['project_id']);
		$user = Dever::db('component/user')->one($user);

		# 获取类目
		$result = $wechat->curl('applet_category', $oauth, false);

		$page = 'pages/index/index';

		$version = Dever::db('component/version')->one($info['version_id']);

		if ($version) {
			$pageInfo = Dever::db('component/page')->getOne(array('option_template_id' => $version['template_id']));

			if ($pageInfo) {
				$page = $pageInfo['pagepath'];
			}
		}
		
		$item = array
		(
			'address' => $page,
			'tag' => str_replace(',', ' ', $user['tag']),
			'title' => $user['name'],
		);

		if (isset($result['category_list'][0]['first_class'])) {
			$item += $result['category_list'][0];
		}

		$oauth['item_list'][] = $item;
		return $oauth;
	}
}